#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include "tenlab_preamble.c"



// Sample Functions in the Language

TENLAB_Tensor double_and_display_tensor(TENLAB_Tensor X)
{
	for(int i = 1; i <= X.cur_content_length; i++)
	{
		X.Content[i-1]=X.Content[i-1] * 2;
		printf("%f\n",X.Content[i-1]);
	}
	return X;
}

TENLAB_Tensor double_tensor(TENLAB_Tensor X)
{
	for(int i = 1; i <= X.cur_content_length; i++)
	{
		X.Content[i-1]=X.Content[i-1] * 2;
	}
	return X;
}

TENLAB_Tensor double_tensor_by_element(TENLAB_Tensor X, TENLAB_Tensor Y)
{
	for(int i = 1; i <= X.cur_content_length; i++)
	{
		X.Content[i-1]=Y.Content[i-1] ;
	}
	return X;
}


int main(){
	printf("Tensor Creation Test: ");
	TENLAB_Tensor A;
	TENLAB_Tensor_create(&A);
	printf("Success!\n");
	printf("Tensor Element Addition Test: ");
	int i;
	for(i = 1; i <= 5; i++)
		TENLAB_add_element(&A,(double)i);
	printf("Success!\n");
	printf("Tensor Checking Test: ");
	TENLAB_Tensor B;
	TENLAB_Tensor_create(&B);
	for(i = 1; i <= 3; i++)
		TENLAB_add_element(&B,(double)i);
	TENLAB_Tensor_check_size(&A,&B);
	printf("Success!\n");
	printf("Tensor Access Test: \n");
	for(i = 1; i <= A.cur_content_length; i++)
	{
		A.Content[i-1]=A.Content[i-1] * 2;
		printf("%f\n",A.Content[i-1]);
	}
	printf("Success!\n");
	TENLAB_Tensor C;
	TENLAB_Tensor_create(&C);
	printf("Tensor Duplication Test: \n");
	TENLAB_Tensor_duplicate(&C,&A);
	printf("Success!\n");
	printf("Tensor Content Duplication Test: \n");
	for(i = 1; i <= C.cur_content_length; i++)
	{
		C.Content[i-1]=C.Content[i-1] * 2;
		printf("%f != %f\n",A.Content[i-1],C.Content[i-1]);
	}
	printf("Success!\n");
	printf("Tensor Memory Test (Code Generation Prototype): \n");
	double_and_display_tensor(A);
	for(i = 1; i <= A.cur_content_length; i++)
	{
		A.Content[i-1]=A.Content[i-1] / 2;
		printf("%f\n",A.Content[i-1]);
	}
	printf("Specific Element Assignment Test: \n");
	TENLAB_Tensor A_pos;
	TENLAB_Tensor_create(&A_pos);
	TENLAB_add_element(&A_pos,4.0);
	TENLAB_add_element_at_specific_position(&A,&A_pos,100.0);
	for(i = 1; i <= A.cur_content_length; i++)
	{
		printf("%f\n",A.Content[i-1]);
	}
	printf("Success!\n");
	printf("Implicit Call Test: \n");
	TENLAB_Tensor_print(double_tensor(A));
	printf("Success!\n");
	printf("Destruction Test: \n");
	TENLAB_Tensor_destroy(&A);
	TENLAB_Tensor_create(&A);
	TENLAB_Tensor_destroy(&B);
	TENLAB_Tensor_create(&B);
	printf("Success!\n");
	printf("Pointing Test: \n");
	for(i = 1; i <= 5; i++)
		TENLAB_add_element(&A,(double)i);
	for(i = 1; i <= 5; i++)
		TENLAB_add_element(&B,(double)i);
	for(i = 1; i <= 5; i++)
		B.Content[i-1]=A.Content[i-1];
	printf("Function Test: \n");
	A=double_tensor(A);
	TENLAB_Tensor_print(A);
	TENLAB_Tensor_print(B);
	printf("Success!\n");
	printf("Shaping Test: \n");
	TENLAB_add_shape(&A,5);
	printf("Success!\n");
	printf("Shaping Test: \n");
	TENLAB_Tensor D;
	printf("Success!\n");
	TENLAB_assign(&A,10);
	printf("Printing A: \n");
	TENLAB_Tensor_print(A);
	printf("Printing B: \n");
	TENLAB_Tensor_print(B);
	TENLAB_assign(&A,B);
	printf("Printing A: \n");
	TENLAB_Tensor_print(A);
}