%% TENLAB Demo 1: Fibonacci Graphs
% by Mehmet Kerem Turkcan

disp('Fibonacci Demo:');
mex tenlab_demo_1.cpp;
X=10;
[Y,Z]=tenlab_demo_1(X);
plot(Z(2:end),Y(2:end));
title('TENLAB Demo 1: Fibonacci');
xlabel('n');
ylabel('F(n)');
disp('Successful!');
axis tight;

%% TENLAB Demo 2:
% by Mehmet Kerem Turkcan

disp('Matrix Multiplication Demo (Doubling):');
mex tenlab_demo_2.cpp;
disp('Input:');
X=[5,11;13,7];
disp(X);
disp('Output (After Doubling):');
Y=tenlab_demo_2(X);
disp(Y);
disp('Successful!');


%% TENLAB Demo 3: Automatic Matrix Multiplication
% by Mehmet Kerem Turkcan

disp('Matrix Multiplication Demo:');
mex tenlab_demo_3.cpp;
tenlab_demo_3();
disp('Successful!');

disp('MATLAB Equivalent:');
X = [3,4,4;5,6,7];
Y = [1,2;3,4;5,6];
Z = X' * Y';
disp(Z(:));

%% TENLAB Demo 4: Speed Comparison
% by Mehmet Kerem Turkcan
tic;
mex tenlab_demo_3.cpp;
MEX_time=toc;
tic;
for i=1:10000
disp('Matrix Multiplication Demo:');
tenlab_demo_3();
disp('Successful!');
end;
TENLAB_time=toc;
tic;
for i=1:10000
disp('MATLAB Equivalent:');
% X = [3,4,4;5,6,7]';
% Y = [1,2;3,4;5,6]';
X = [3,5;4,6;4,7];
Y = [1,3,5;2,4,6];
Z = X * Y;
disp(Z(:));
clear X; clear Y; clear Z;
end;
MATLAB_time=toc;

disp(['TENLAB took ' num2str(TENLAB_time+MEX_time) ' seconds on 10000 runs']);
disp(['MATLAB took ' num2str(MATLAB_time) ' seconds on 10000 runs']);
disp(['TENLAB Speedup Factor: ' num2str(MATLAB_time/(TENLAB_time+MEX_time)) '']);
disp(['Post-Compilation Speedup Factor: ' num2str(MATLAB_time/TENLAB_time) '']);