{ open Parser }

rule token = parse
  [' ' '\t' '\r' '\n']  { token lexbuf }            (* Whitespace *)
| "%"  { comment lexbuf }          (* Comments   *)
| '('  { LPAREN }
| ')'  { RPAREN }
| '['  { LNPAREN }
| ']'  { RNPAREN }
| '{'  { LBRACE }
| '}'  { RBRACE }
| ':'  { COLON }
| ".*"  { TENPROD }
| ';'  { SEMI }
| ','  { COMMA }
| '+'  { PLUS }
| '-'  { MINUS }
| '*'  { TIMES }
| '/'  { DIVIDE }
| '='  { ASSIGN }
| "=="  { EQ }
| "!="  { NEQ }
| '<'  { LT }
| "<="  { LEQ }
| ">"  { GT }
| ">="  { GEQ }
| "if"  { IF }
| "function"  { FUNCTION }
| "end"  { END }
| "else"  { ELSE }
| "for"  { FOR }
| "while"  { WHILE }
| "return"  { RETURN }
| "tensor"  { TENSORDEF }
| "clear"  { CLEAR }
| "clean"  { CLEAN }
| '['(['0'-'9' ',' '[' ']' 'a'-'z' 'A'-'Z']|
  ((((['0'-'9']+['.']['0'-'9']*)|(['0'-'9']*['.']['0'-'9']+))
  (['e' 'E']['-' '+']?['0'-'9']+)?)|(['0'-'9']+(['e' 'E']
  ['-' '+']?['0'-'9']+))))+']'+ as lxm  { TENSOR(lxm) }
| ['0'-'9']+ as lxm  { LITERAL(lxm) }
| ((((['0'-'9']+['.']['0'-'9']*)|(['0'-'9']*['.']['0'-'9']+))
  (['e' 'E']['-' '+']?['0'-'9']+)?)|(['0'-'9']+(['e' 'E']
  ['-' '+']?['0'-'9']+))) as lxm  { LITERAL(lxm) }
| ['a'-'z' 'A'-'Z']['a'-'z' 'A'-'Z' '0'-'9' '_']* as lxm  { ID(lxm) }
| eof  { EOF }
| _ as char  { raise (Failure("illegal character " ^ Char.escaped char)) }

and comment = parse
  ['\r' '\n']  { token lexbuf }
| _  { comment lexbuf }
