(* TENLAB Master Module by Mehmet Kerem Turkcan*)
(* Based on the corresponding MICROC Module    *)

type action = Ccode | Mex

let _ =
  let action = if Array.length Sys.argv > 1 then
    List.assoc Sys.argv.(1) [ ("-c", Ccode);
			      ("-m", Mex) ]
  else Ccode in
  let lexbuf = Lexing.from_channel stdin in
  let program = Parser.program Scanner.token lexbuf in
  match action with
    (*
	If not MEX, simply compile into C.
	*)
    Ccode -> let listing =
      Ccode.string_of_prog (Compile.translate program 0)
    in print_endline listing
    (*
	If MEX, change the interface to compile into MEX.
	*)
  | Mex -> let listing =
      Ccode.string_of_prog_mex (Compile.translate program 1)
    in print_endline listing
